Lightmapper QML Type | Qt Quick 3D | Qt 6.11.1
Description: Specifies lightmap baking settings for a scene.

- Qt 6.11
- Qt Quick 3D
- QML Types
- Lightmapper
- Qt Quick 3D | Commercial or GPLv3

# Lightmapper QML Type

Specifies lightmap baking settings for a scene. More...

Import Statement: | `import QtQuick3D`
Since: | Qt 6.4
Inherits: | QtObject

- List of all members, including inherited members

## Properties

- adaptiveBiasEnabled : bool
- bias : real
- bounces : int
- denoiseSigma : real `(since 6.10)`
- indirectLightEnabled : bool
- indirectLightFactor : real
- indirectLightWorkgroupSize : int
- opacityThreshold : real
- samples : int
- source : url `(since 6.10)`
- texelsPerUnit : real `(since 6.10)`

## Detailed Description

Used when baking direct and indirect lighting. Most of these settings are not relevant at other times, such as when using already generated lightmaps to render a scene. The exception is source, though this has a sensible default for development.

On a successfull bake a single file will be generated at the value specified by source. This binary file contains the results of the bake, including the per-model lightmaps and the mesh files with lightmap-compatible UVs. The individual model data is accessed via BakedLightmap::key.

The data contained in the resulting lightmap file is all tightly coupled to each other and to the current scene state. This means that any modifications to the original mesh files, Lightmapper settings or other scene changes will require a new bake to be executed to see the updated result.

Note: As of Qt 6.4, lightmap baking is in an early technology preview state. Changes to features, quality, and API are likely to happen in future releases.

The Lightmapper object works in combination with:

- Model::bakedLightmap and the associated BakedLightmap,
- Model::usedInBakedLighting and Model::texelsPerUnit,
- Light::bakeMode,
- the engine's built-in lightmap baker.

See also Lightmaps and Global Illumination, Qt Quick 3D - Baked Lightmap Example, and Qt Quick 3D - SSGI Lightmap Example.

## Property Documentation

### adaptiveBiasEnabled : bool

Enables applying an additional, dynamic bias based on the surface normal.

The default value is true.

### bias : real

Raycasting bias used during baking. Adapt the value in case artifacts occur, for example in order to reduce undesired shadowing patterns. In many cases the default value is sufficient.

The default value is 0.005.

### bounces : int

The maximum number of indirect light bounces per sample. The value should at least be 1, no point in indirect light calculation otherwise.

The default value is 3.

The value heavily affects both the performance and quality of the resulting lightmaps during lightmap baking.

### denoiseSigma : real `[default: 8, since 6.10]`

This property defines the sigma value of the Non-local means based denoiser. This means that the higher this value is the stronger the blurring will be. Try to keep this value as low as possible to avoid losing visual features while still removing the noise.

This property was introduced in Qt 6.10.

### indirectLightEnabled : bool

Normally there is no need to change this value. The default value is true. Setting this property to false disables indirect light computation during lightmap baking. Thus the resulting texture maps will only contain direct light information. At run time, the engine will continue to use the maps normally, assuming they contain both direct and indirect lighting.

### indirectLightFactor : real

Multiplier for the indirect light amount. While it is the value of 1 (i.e., not affecting the indirect light amount calculation) that provides the strictly correct rendering results, a slightly higher value can often give better looking results when using the lightmap, even with a lower number of bounces.

The default value is 1.

### indirectLightWorkgroupSize : int

The size of the sample workgroups. These workgroups are attempted to be executed in parallel. (the exact behavior depends on the number of CPU cores and the QThreadPool configuration)

The default value is 32. With the default sample count of 256 this means attempting to run 8 groups in parallel per model.

### opacityThreshold : real

The opacity (alpha) threshold below which an object is ignored in ray - mesh intersections when calculating lighting via raytracing. When the opacity falls below the threshold, the model (submesh) will not occlude lights and thus will not generate shadows either.

The default value is 0.5.

Note: The lightmapper takes the material's opacity and the baseColor alpha combined with the base color map's alpha into account. Other sources of semi-transparency, such as the opacity map or alpha cut-off settings are ignored during the lightmap baking process.

### samples : int

The number of samples per lightmap texel.

The default value is 256.

The value heavily affects both the performance and quality of the resulting lightmaps during lightmap baking.

### source : url `[default: file:lightmaps.bin, since 6.10]`

The url for loading the lightmap file at runtime and the output file path on a successful bake.

When baking, the output path will be deduced from the url and it needs to resolve to a regular file location that is writable. By default the value is `file:lightmaps.bin`, which means the file will be put in the current working directory and the final result will instantly appear on a successful bake.

In the same directory as the output file, a `.raw` file is created that contains extra lightmap data used before creating the final lightmap file. This makes it possible to do just denoising without having to bake the whole scene between runs, assuming the `.raw` file is present.

If you want to read the lightmap as a QRC resource you need to embed it in the usual way and add a `:/` or `qrc:/` prefix to the url. The following example always tries to load the lightmap file embedded via resources. First set the value to a writable location and bake. Then copy the generated file into the source directoy. Then by listing the file in the application's CMake project as a resource under the `/lightmaps` PREFIX, lets the build process pick up the file and include it in the executable.

     Lightmapper {
         source: "qrc:/lightmaps/lightmaps.bin"
         // will attempt to load from :/lightmaps/lightmaps.bin at runtime
         // and write a file to lightmaps/lightmaps.bin when baking.
     }

This property was introduced in Qt 6.10.

### texelsPerUnit : real `[default: 1, since 6.10]`

This property defines the unit to texel scale, meaning a `1x1` quad with texelsPerUnit of `32` will take up approximately `32x32` texels in the lightmap.

This property was introduced in Qt 6.10.

See also Model::texelsPerUnit.